// Tactics

// Ordering functions
var dists = [];
var randand;
var randmax;
var minVal;
var armies;
function eventDroidIdle(droid) {
    if (droid.droidType == DROID_CONSTRUCT) {
        return;
    }
    if (droid.group == groups.defenders) {
        orderDroidLoc(droid, DORDER_PATROL, droid.x + 10, droid.y + 10);
    } else if (droid.group == groups.vattackers) {
        sendToVAttack(droid); // Vtol attacking function
    } else if (droid.group != groups.spamborgs) {
        sendToAttack(droid);
    }
}

function sendToAttack(droid) {
    if (droid.group == groups.attackers || droid.group == groups.sensors) {
        var i;
        for (i = 0; i < startPositions.length; i++) {
            dists[i] = [distBetweenTwoPoints(droid.x, droid.y, startPositions[i].x, startPositions[i].y), startPositions[i]];
        }
        dists = sortLi2(dists);
        randmax = (maxPlayers < 5) ? 2 : 3;
        randand = randomNum(randmax) + 1;
        if (droid.player == me && droid.droidType != DROID_CONSTRUCT) {
            orderDroidLoc(droid, (droid.group == groups.sensors) ?
                          DORDER_MOVE : DORDER_SCOUT,
                          dists[randand][1].x,
                          dists[randand][1].y);
        }
    } else if (droid.group == groups.derattackers) {
        do { pl = randomNum(maxPlayers);
        } while (allianceExistsBetween(me, pl));
        estructs = enumStruct(pl, RESOURCE_EXTRACTOR);
        orderDroidLoc(droid, DORDER_SCOUT, estructs[0].x, estructs[0].y);
    }
}

function sendToVAttack(droid) {
    do { pl = randomNum(maxPlayers);
    } while (allianceExistsBetween(me, pl));
    estructs = enumStruct(pl, FACTORY).concat(enumStruct(pl, CYBORG_FACTORY).concat(
               enumStruct(pl, VTOL_FACTORY).concat(enumStruct(pl, RESEARCH_LAB).concat(
               enumStruct(pl, POWER_GEN).concat(enumStruct(pl, DEFENSE))))));
    orderDroidObj(droid, DORDER_ATTACK, estructs[0]);
}

// Attacking function
//function eventObjectSeen(viewer, seen) {
//    if (viewer.type == DROID
//        && viewer.player == me
//        && viewer.droidType != DROID_CONSTRUCT
//        && seen.type != FEATURE && !allianceExistsBetween(
//        viewer.player, seen.player)) {
//        orderDroidObj(viewer, (viewer.droidType == DROID_SENSOR) ? DORDER_OBSERVE : DORDER_ATTACK, seen);
//    }
//} (unused)

// This function helps to attack enemies not seen by a droid.
var midroids;
function eventAttacked(obj, attacker) {
    if (obj.player == me
        && obj.type == STRUCTURE
        && obj.stattype != RESOURCE_EXTRACTOR // We don't want you protecting any derricks please!
        && !allianceExistsBetween(obj.player, attacker.player)) {
            debug_("Protecting base against " + attacker);
            midroids = enumGroup(groups.defenders);
            var i;
            for (i = 0; i < midroids.length; i++) {
                orderDroidObj(midroids[i], DORDER_ATTACK, attacker);
            } 
    }
    if (obj.player == me
        && obj.type == DROID
        && obj.health < 50
        && !allianceExistsBetween(obj.player, attacker.player)) {
            debug_("Repairing " + obj);
            midroids = enumGroup(groups.repairs);
            var i;
            for (i = 0; i < midroids.length; i++) {
                if (midroids[i].order != DORDER_REPAIR) {
                    orderDroidObj(midroids[i], DORDER_REPAIR, obj);
                    break;
                }
            }
            orderDroid(obj, DORDER_RTR);
    }
}
